/* ------------------------------------------------------ */
/*                      UNLINK.C                          */
/*            (c)  Kai Jendrian & TOOLBOX                 */
/*     Programm  zum Ersatz des DOS-Kommandos DEL         */
/*     Erstellt mit Turbo-C 2.0 und Turbo-Debugger 1.0    */
/* Modell :  Tiny                                         */
/* Linken : tlink lib\c0t out\unlink,unlink.com,,lib\cs /t*/
/*                                                        */
/* ------------------------------------------------------ */
#include <conio.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <dir.h>
#include <alloc.h>
#include <ctype.h>

#define MAXLEN 80  /* Maximale Lnge fr einen Dateinamen */

main(int argc, char *argv[])
{
  struct ffblk file;
  char (*datlist)[MAXLEN];
  char *temp;
  int *datatr;
  register i;
  int listlen = 0, lastentry, ch, error;

/* Speicherplatz fr die maximale Anzahl an zu lschenden */
/* Dateien bereitstellen                                  */

  datatr  = (int*)calloc(argc, sizeof(int));
  datlist = calloc(argc, MAXLEN);
  if (argc==1) {
    printf("Der Befehl UNLINK hat folgendes Format:\n\n");
    printf("UNLINK Dateiname [-q] Dateiname [-q] ...\n\n");
    printf("Bei Dateiname sind Wildcards erlaubt. ");
    printf("Der optionale\n");
    printf("Paramter -q bewirkt, da jeder Lschvorgang ");
    printf("besttigt\n");
    printf("werden mu.\n");
    return;
  }
  for (i = 1; i < argc; i++) {
    if (*argv[i] != '-')
                   /* Wenn der Parameter keine Option ist */
                   /* fge ihn in die Dateiliste ein.     */
      strncpy(datlist[listlen++], argv[i],
              min(strlen(argv[i]), MAXLEN));
    else {
                 /* Wenn der Parameter die Option -q ist  */
                 /* Setze das entsprechende Dateiattribut */
                 /* auf 1, d.h. auf Lschen besttigen.   */
      if(*(argv[i]+1) == 'q' && listlen)
        datatr[listlen-1] = 1;
      }
  }
          /* Fhre das Lschen anhand der oben erstellten */
          /* Listen durch.                                */
  for(i = 0; i < listlen; i++) {
                   /* Prfe ob ein entsprechneder Eintrag */
                   /* auf dem Medium vorhanden ist.       */
    lastentry = findfirst(datlist[i], &file, 0);
    if(lastentry)
      printf("\nKeine passende Datei %s gefunden!",
             datlist[i]);
    while(!lastentry) {
        /* Solange ein weiterer Eintrag gefunden wird     */
        /* speichere in temp die Adresse des am weitesten */
        /* rechts stehenden Zeichen '\' - temp ist also   */
        /* ein Zeiger auf das Ende der Pfadangabe in      */
        /* datlist[i].                                    */
      temp = strrchr(datlist[i],'\\');
        /* Wenn das Zeichen '\' nicht gefunden wurde,     */
        /* suche nach dem Zeichen ':', das eine           */
        /* Laufwerksangabe abschliet.                    */
        /* Speichere einen Zeiger darauf in temp.         */
      if (!temp) temp = strrchr(datlist[i], ':');
        /* Wenn eins der beiden oben gesuchten Zeichen    */
        /* gefunden wurde, hnge den durch file.ff_name   */
        /* spezifizierten Dateinamen an datlist[i] an.    */
      if (temp) {
        *(temp+1) = '\0';
        strcat(datlist[i], file.ff_name);
      }
        /* Wenn keins der beiden Zeichen gefunden wurde,  */
        /* ist in dem entsprechenden Parameter keine      */
        /* Laufwerks- oder Pfadangabe spezifiziert und    */
        /* der Name der zu Lschenden Datei mu von       */
        /* file.ff_name in datlist[i] kopiert werden.     */
      else
        strcpy(datlist[i], file.ff_name);
        /* Wenn das zu dem Dateinamen datlist[i]          */
        /* gehrende Attribut datatr[i] auf 1 gesetzt     */
        /* wurde, la den Lschvorgang besttigen und     */
        /* fhre ihn gegebenenfalls aus. Falls der Lsch- */
        /* vorgang nicht korrekt ausgefhrt werden konnte,*/
        /* gib eine Fehlermeldung aus.                    */
      if (datatr[i]) {
        printf("\nDatei %-14s lschen? <J/N> : ",
               file.ff_name);
        putch(ch = toupper(getch()));
        if (ch == 'J') {
          error = unlink(datlist[i]);
          if (!error)
            printf("   Datei erfolgreich gelscht!");
          else
            printf("   Fehler beim Lschen der Datei!");
         }
      }
      /* Wenn das attribut datatr[i] nicht auf 1 gesetzt  */
      /* wurde, lsche die in datlist[i] angegebene Datei */
      /* und gib, falls erforderlich, eine Fehlermeldung  */
      /* aus.                                             */
      else {
        error = unlink(datlist[i]);
        if (!error)
          printf("\nDatei %-14s gelscht!", file.ff_name);
        else
          printf("\nFehler beim Lschen der Datei %s!",
                 file.ff_name);
      }
                               /* Suche die nchste Datei */
      lastentry = findnext(&file);
    }
  }
               /* Gib belegten Speicherplatz wieder frei. */
  free(datlist);
  free(datatr);
}
/* ------------------------------------------------------ */
/*                  Ende von UNLINK.C                     */
